{ ***********************************************************************

         NAME: Steven Lawrance
         PERIOD: 4th


         DATE ASSIGNED: 12-5-1994
         PROGRAM NAME: Jingle Bells for DOS

  *********************************************************************** }

PROGRAM JingleBells(output);

USES CRT;

CONST
   C = 262;
   D = 294;
   E = 330;
   F = 349;
   G = 392;
   A = 440;
   B = 494;
   C5 = 523;
   D5 = 587;
   E5 = 659;
   F5 = 698;
   G5 = 784;
   Qnote = 550;

VAR
   Fsharp : integer;
   Hnote, Enote, Snote : integer;
   SongLCV : integer;
   X, Y : integer;
   BoxL, BoxR : integer;
   SoundChar : char;

(*  This procedure plays a note and processes the string.  Here are
    the contents and punctuation for the string:
    ~  This terminates a string.  This is required at the end!  If it is not
       present, unknown garbage may print on the screen!
    ^  This goes to the next line.  The X position on the screen is
       resetted to the left of the text box.

    Here's how to define a text box and use this procedure:
    VAR
       X, Y, BoxL, BoxR : integer;
       SoundChar : char;
    BEGIN
       BoxL := 20;      This defines the 20th column as the left of the
                        text box

       BoxR := 15;      This defines the right of the box as the 15th
                        column from the left of the box.  The real column
                        is BoxR + BoxL

       X := BoxL        This sets the X value to the left of the box

       Y := 5           This sets the row to 5.  Note: there are no
                        values for the top and bottom in this version

       SoundChar := 'Y';  The SoundChar variable, if set to Y or y, will
                          allow the Play procedure to play music.

           This writes text and plays the note.  Note: the values for
           note and wait are program-defined and the programmer must
           put values in them.  The ^ goes to the next line.

       Play(note, wait, 'String to write~');
       Play(note, wait, 'Go to next line^~');  *)

Procedure Play (Note:integer; Wait:integer; MusicString:string);
   VAR
      LCV : integer;
      ProcessedYN : boolean;
   BEGIN
      LCV := 0;
      REPEAT
         BEGIN
            LCV := LCV + 1;
            ProcessedYN := false;
            CASE MusicString[LCV] OF
               '^' : BEGIN
                        Y := Y + 1;
                        X := BoxL;
                        ProcessedYN := true;
                     END;
               '~' : BEGIN
                        LCV := 10;
                        ProcessedYN := true;
                     END;
            END;
            GotoXY(X, Y);
            IF ProcessedYN = false THEN
               BEGIN
                  X := X + 1;
                  write(MusicString[LCV]);
               END;
            IF X >= BoxR + BoxL THEN
               BEGIN
                  Y := Y + 1;
                  X := BoxL;
               END;
         END;
      UNTIL LCV >= 10;
      IF (SoundChar = 'y') OR (SoundChar = 'Y') THEN
         Sound(Note);
      Delay(Wait);
      IF (SoundChar = 'y') OR (SoundChar = 'Y') THEN
         NoSound;
   END;

BEGIN
   (*  Initialize  *)
   TextBackground(Black);
   TextColor(LightGray);
   clrscr;
   writeln('Jingle Bells for DOS');
   writeln;
   writeln('Programmed by Steven Lawrance');
   writeln;
   writeln;
   writeln('Merry Christmas!');
   writeln;
   writeln;
   Delay(1000);
   write('Do you want sounds? ');
   readln(SoundChar);
   clrscr;
   Fsharp := round(sqrt(1.0 * F * G));
   Hnote := Qnote * 2;
   Enote := round(Qnote / 2);
   Snote := round(Qnote / 4);
   Y := 5;
   BoxL := 20;
   BoxR := 55;
   X := BoxL;


   (*  Create Color Screen 1  *)
   TextColor(White);
   write('      ');
   TextColor(Brown);
   writeln('/\');
   TextColor(White);
   write('    ');
   TextColor(Brown);
   writeln('/    \');
   writeln('   /        \');
   write('    o    o      ');
   TextColor(Green);
   writeln('Ŀ');
   TextColor(Brown);
   write('    o    o      ');
   TextColor(Green);
   writeln('                                                       ');
   TextColor(Brown);
   write('        ');
   TextColor(Green);
   writeln('                                                       ');
   write('                                                             ');
   writeln('            ');
   write('                                                               ');
   writeln('          ');
   write('                  ');
   writeln('');
   TextColor(DarkGray);
   GotoXY(20, 5);
   write('Dashing through the snow, In a one-horse open sleigh,');
   GotoXY(20, 6);
   write('Over the fields we go, Laughing all the way;');
   GotoXY(20, 7);
   write('Bells on bobtail ring, Making spirits bright;');
   GotoXY(20, 8);
   write('Oh what fun it is to sing a sleighing song tonight!');
   GotoXY(1, 12);
   TextColor(Red);
   writeln;
   writeln;
   writeln('         *  *  *  *');
   writeln('         ');
   writeln('         *  *  *  *');
   GotoXY(40, 11);
   TextColor(Red);
   write('         *  *  *  *');
   GotoXY(40, 12);
   write('         ');
   GotoXY(40, 13);
   write('         *  *  *  *');
   GotoXY(50, 16);
   TextColor(Green);
   TextBackground(Green);
   write('  ');
   GotoXY(48, 17);
   write('      ');
   GotoXY(46, 18);
   write('          ');
   GotoXY(44, 19);
   write('              ');
   GotoXY(42, 20);
   write('                  ');
   GotoXY(40, 21);
   write('                      ');
   GotoXY(50, 22);
   TextBackground(Black);
   TextColor(Brown);
   write('');
   GotoXY(50, 23);
   write('');
   TextColor(White);


   (*  Play the First Part of the Song  *)
   Play(D, Enote, 'Dash~');
   Play(B, Enote, 'ing~');
   Play(A, Enote, ' through~');
   Play(G, Enote, ' the~');
   Play(D, Qnote, ' snow, ~');

   Delay(Enote);
   Play(D, Snote, 'In~');
   Play(D, Snote, ' a~');
   Play(D, Enote, ' one~');
   Play(B, Enote, '-horse~');
   Play(A, Enote, ' o~');
   Play(G, Enote, 'pen~');
   Play(E, Qnote, ' sleigh,^~');

   Delay(Qnote);
   Play(E, Enote, 'Over~');
   Play(C5, Enote, ' the~');
   Play(B, Enote, ' fields~');
   Play(A, Enote, ' we~');
   Play(Fsharp, Qnote, ' go,~');

   Delay(Qnote);
   Play(D5, Enote, ' Laugh~');
   Play(D5, Enote, 'ing~');
   Play(C5, Enote, ' all~');
   Play(A, Enote, ' the~');
   Play(B, Qnote, ' way;^~');

   Delay(Qnote);
   Play(D, Enote, 'Bells~');
   Play(B, Enote, ' on~');
   Play(A, Enote, ' bob~');
   Play(G, Enote, 'tail~');
   Play(D, Qnote, ' ring,~');

   Delay(Qnote);
   Play(D, Enote, ' Mak~');
   Play(B, Enote, 'ing~');
   Play(A, Enote, ' spir~');
   Play(G, Enote, 'its~');
   Play(E, Qnote, ' bright;^~');

   Delay(Qnote);
   Play(E, Enote, 'Oh~');
   Play(C5, Enote, ' what~');
   Play(B, Enote, ' fun~');
   Play(A, Enote, ' it~');
   Play(D5, Enote, ' is~');
   Play(D5, Enote, ' to~');
   Play(D5, Enote, ' sing~');
   Play(D5, Enote, ' a~');
   Play(E5, Enote, ' sleigh~');
   Play(D5, Enote, 'ing~');
   Play(C5, Enote, ' song~');
   Play(A, Enote, ' to~');
   Play(G, Qnote, 'night!^~');
   Delay(Qnote);


   (*  Create Color Screen 2  *)
   clrscr;
   TextColor(Brown);
   GotoXY(1, 2);
   writeln('          /\                /\');
   writeln('        /    \            /    \');
   writeln('      /        \        /        \');
   write('                                        ');
   TextColor(White);
   writeln('Merry Christmas!!');
   TextColor(Brown);
   write('       ');
   TextColor(LightGray);
   write('O    O ');
   TextColor(Brown);
   write('         ');
   TextColor(LightGray);
   write('O    O ');
   TextColor(Brown);
   writeln('');
   writeln('                                       ͸');
   write('');
   writeln('');
   GotoXY(12, 15);
   TextColor(Green);
   BoxL := 13;
   X := 13;
   Y := 16;
   write('Ŀ');
   FOR SongLCV := 16 TO 19 DO
      BEGIN
         GotoXY(12, SongLCV);
         write('                                                       ');
      END;
   GotoXY(12, 20);
   write('');
   GotoXY(30, 11);
   TextColor(Red);
   write('         *  *  *  *');
   GotoXY(30, 12);
   write('         ');
   GotoXY(30, 13);
   write('         *  *  *  *');
   GotoXY(5, 12);
   TextColor(LightGray);
   write('         *  *  *  *');
   GotoXY(5, 13);
   write('         ');
   GotoXY(5, 14);
   write('         *  *  *  *');
   TextColor(DarkGray);
   GotoXY(13, 16);
   write('Jingle bells, jingle bells, jingle all the way!');
   GotoXY(13, 17);
   write('Oh, what fun is is to ride in a one horse open sleigh!');
   GotoXY(13, 18);
   write('Jingle bells, jingle bells, jingle all the way!');
   GotoXY(13, 19);
   write('Oh, what fun is is to ride in a one horse open sleigh!');
   TextColor(White);


   (*  Play The Repeating Part of the Song  *)
   FOR SongLCV := 1 TO 2 DO
      BEGIN
         Play(B, Enote, 'Jin~');
         Play(B, Enote, 'gle~');
         Play(B, Qnote, ' bells,~');
         Play(B, Enote, ' jin~');
         Play(B, Enote, 'gle~');
         Play(B, Qnote, ' bells,~');
         Play(B, Enote, ' jin~');
         Play(D5, Enote, 'gle~');
         Play(G, round(Enote * 1.5), ' all~');
         Play(A, Enote, ' the~');
         Play(B, Hnote, ' way!^~');

         Play(C5, Enote, 'Oh,~');
         Play(C5, Enote, ' what~');
         Play(C5, round(Enote * 1.5), ' fun~');
         Play(C5, Enote, ' it~');
         Play(C5, Enote, ' is~');
         Play(B, Enote, ' to~');
         Play(B, Enote, ' ride~');
         Play(B, Snote, ' in~');
         Play(B, Snote, ' a~');

         IF SongLCV = 1 THEN
            BEGIN
               Play(B, Enote, ' one~');
               Play(A, Enote, ' horse~');
               Play(A, Enote, ' o~');
               Play(B, Enote, 'pen~');
               Play(A, Qnote, ' sleigh!~');
               Play(D5, Qnote, '^~');
            END;

         IF SongLCV = 2 THEN
            BEGIN
               Play(D5, Enote, ' one~');
               Play(D5, Enote, ' horse~');
               Play(C5, Enote, ' o~');
               Play(A, Enote, 'pen~');
               Play(G, Hnote, ' sleigh!^^~');
            END;
      END;

   NoSound;  (*  Stop any sounds (even none exist)  *)

   Delay(500);  (*  Reset the screen and clear it  *)
   TextBackground(0);
   TextColor(White);
   clrscr;
END.
